%define name		jasper4
%define full_name	jakarta-%{name}
%define version		4.1.30
%define majversion	4.1
%define release		1jpp
%define section		free

%define summary		Apache JSP Engine, RI for Servlet JSP 1.2 API
%define license		Apache Software License
%define distribution	JPackage
%define vendor		JPackage Project

%define jname		jasper4
%define tcuid		91

%define packname 	jakarta-tomcat-%{version}
%define packdname	jakarta-tomcat-%{version}-src
%define jpackdname	jakarta-tomcat-connectors-%{version}-src

# FHS 2.2 compliant tree structure
# see http://www.pathname.com/fhs/2.2/
%define confdir		%{_sysconfdir}/%{name}
%define logdir		%{_localstatedir}/log/%{name}
%define homedir		%{_datadir}/%{name}
%define bindir		%{_datadir}/%{name}/bin
%define tempdir		%{_localstatedir}/cache/%{name}/temp
%define workdir		%{_localstatedir}/cache/%{name}/work
%define appdir		%{_localstatedir}/lib/%{name}/webapps
%define serverdir	%{_localstatedir}/lib/%{name}/server
%define commondir	%{_localstatedir}/lib/%{name}/common
%define shareddir	%{_localstatedir}/lib/%{name}/shared

Summary: 		%{summary}
Name: 			%{name}
Version: 		%{version}
Release: 		%{release}
Epoch:			0
License:		%{license}
Vendor:			%{vendor}
Distribution:		%{distribution}
Group: 			Development/Compilers
URL: 			http://jakarta.apache.org/tomcat/
BuildArch: 		noarch
Source:			http://jakarta.apache.org/builds/jakarta-tomcat-4.0/release/v%{version}/src/%{packdname}.tar.gz
Source1:		TOMCAT4.README.RPM
Patch0:			jasper4-build_xml.patch
Patch1:			jasper4_command.patch
BuildRoot:		%{_tmppath}/%{name}-root-%{version}

Requires:		ant >= 0:1.5.4, jpackage-utils >= 0:1.5.32
Requires:               servletapi4 >= 0:4.0.4

Buildrequires:		jpackage-utils >= 0:1.5.32
BuildRequires:		ant >= 0:1.5.4, ant-optional >= 0:1.5.4
BuildRequires:          servletapi4 >= 0:4.0.4
BuildRequires:          servletapi4-javadoc >= 0:4.0.4

%description
JSP engine that conforms to the JSP 1.2
specifications from Java Software.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.


%prep
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%setup -q -c -T -a 0

cd %{packdname}
%patch0
%patch1

%build
export CLASSPATH=%(build-classpath xml-commons-apis xalan-j2 servletapi4)

# Remove pre-build jars
for dir in %{packdname} ; do
    find $dir -name "*.jar" -exec rm -f {} \;
done

# build jasper 4
cd %{packdname}
pushd jasper

cat >> build.properties <<EOBP
ant.jar=%{_javadir}/ant.jar
jtc.home=$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-connectors-%{version}-src/
jasper.home=./jasper
servlet.jar=$(build-classpath servletapi4)
servlet.doc=%{_javadocdir}/servletapi4
EOBP

# can't use jikes to build tomcat4 (strange)
ant -Djava.home=%{java_home} -Dbuild.compiler=modern javadoc

sed -e 's|tomcat|jasper|g' -e 's|TOMCAT|JASPER|g' build/bin/jasper.sh > build/bin/jasper.sh.mod
cp build/bin/jasper.sh.mod build/bin/jasper.sh
 
popd


%install
rm -rf $RPM_BUILD_ROOT

# install RPM README
cp %{SOURCE1} .

cd %{packdname}
# bins
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install jasper/build/bin/jspc.sh     $RPM_BUILD_ROOT%{_bindir}/jspc4.sh
install jasper/build/bin/jasper.sh     $RPM_BUILD_ROOT%{_bindir}/jasper4.sh
install catalina/src/bin/setclasspath.sh \
		$RPM_BUILD_ROOT%{_bindir}/jasper4_classpath.sh
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install jasper/build/shared/lib/jasper-compiler.jar \
                     $RPM_BUILD_ROOT%{_javadir}/%{name}-compiler-%{version}.jar
ln -s %{name}-compiler-%{version}.jar \
                     $RPM_BUILD_ROOT%{_javadir}/%{name}-compiler.jar
install jasper/build/shared/lib/jasper-runtime.jar \
                     $RPM_BUILD_ROOT%{_javadir}/%{name}-runtime-%{version}.jar
ln -s %{name}-runtime-%{version}.jar \
                     $RPM_BUILD_ROOT%{_javadir}/%{name}-runtime.jar
# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr jasper/build/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} \
                     $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# FHS compliance patches, not easy to track them all boys :)
#
#i=$RPM_BUILD_ROOT%{_bindir}/jasper4.sh
#perl -pi -e "s|\@\@\@TCCONF\@\@\@|%{confdir}|g;" $i
#perl -pi -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g;" $i
#perl -pi -e "s|\@\@\@TCBIN\@\@\@|%{bindir}|g;" $i
#perl -pi -e "s|\@\@\@TCCOMMON\@\@\@|%{commondir}|g;" $i
#perl -pi -e "s|\@\@\@TCSERVER\@\@\@|%{serverdir}|g;" $i
#perl -pi -e "s|\@\@\@TCSHARED\@\@\@|%{shareddir}|g;" $i
#perl -pi -e "s|\@\@\@TCAPP\@\@\@|%{appdir}|g;" $i
#perl -pi -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g;" $i


%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(644,root,root,755)
%doc TOMCAT4.README.RPM %{packdname}/{LICENSE,README*,RELE*}
%doc %{packdname}/jasper/doc/jspc.html
%{_javadir}/*.jar
%attr(755,root,root)            %{_bindir}/*


%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}


%changelog
* Wed Feb 25 2004 Kaj J. Niemi <kajtzu@a51.org> 0:4.1.30-1jpp
- Update to 4.1.30

* Wed Jan 28 2004 Ralph Apel <r.apel@r-apel.de> 0:4.1.29-2jpp
- derived this separate package from tomcat4-4.1.29-2jpp
- its purpose is to provide standalone jasper4-runtime and jasper4-compiler
  as well as jasper-javadoc
- Jakarta original style jasper4.sh and jspc4.sh are included
- doesn't conflict with tomcat4 <= 0:4.1.29
